using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Security.Permissions;

namespace RSSStoreViewer
{

	/// <summary>
	/// Summary description for FeedViewer.
	/// </summary>
	public class FeedViewer : System.Windows.Forms.Form
	{
        private FeedStore fs;
        private int m_order;

        private System.Windows.Forms.TreeView treeView1;
        private System.Windows.Forms.Splitter splitter1;
        private System.Windows.Forms.ListView listView1;
        private System.Windows.Forms.Splitter splitter2;
        private AxSHDocVw.AxWebBrowser axWebBrowser1;
        private System.Windows.Forms.ImageList imageList1;
        private System.Windows.Forms.ColumnHeader columnHeader1;
        private System.Windows.Forms.ColumnHeader columnHeader2;
        private System.Windows.Forms.StatusBar statusBar1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.ContextMenu contextMenuTreeView;
        private System.Windows.Forms.ContextMenu contextMenuListView;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.ComponentModel.IContainer components;

		public FeedViewer()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            m_order = 1;
            PopulateTree();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FeedViewer));
            this.treeView1 = new System.Windows.Forms.TreeView();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.listView1 = new System.Windows.Forms.ListView();
            this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.axWebBrowser1 = new AxSHDocVw.AxWebBrowser();
            this.statusBar1 = new System.Windows.Forms.StatusBar();
            this.contextMenuTreeView = new System.Windows.Forms.ContextMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.contextMenuListView = new System.Windows.Forms.ContextMenu();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).BeginInit();
            this.SuspendLayout();
            // 
            // treeView1
            // 
            this.treeView1.ContextMenu = this.contextMenuTreeView;
            this.treeView1.Dock = System.Windows.Forms.DockStyle.Left;
            this.treeView1.ImageList = this.imageList1;
            this.treeView1.Location = new System.Drawing.Point(0, 0);
            this.treeView1.Name = "treeView1";
            this.treeView1.Size = new System.Drawing.Size(224, 527);
            this.treeView1.TabIndex = 0;
            this.treeView1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.OnViewerKeystroke);
            this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.onTreeItemSelect);
            // 
            // imageList1
            // 
            this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // splitter1
            // 
            this.splitter1.Location = new System.Drawing.Point(224, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 527);
            this.splitter1.TabIndex = 1;
            this.splitter1.TabStop = false;
            // 
            // listView1
            // 
            this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                        this.columnHeader1,
                                                                                        this.columnHeader2});
            this.listView1.ContextMenu = this.contextMenuListView;
            this.listView1.Dock = System.Windows.Forms.DockStyle.Top;
            this.listView1.FullRowSelect = true;
            this.listView1.Location = new System.Drawing.Point(227, 0);
            this.listView1.MultiSelect = false;
            this.listView1.Name = "listView1";
            this.listView1.Size = new System.Drawing.Size(517, 168);
            this.listView1.TabIndex = 2;
            this.listView1.View = System.Windows.Forms.View.Details;
            this.listView1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.OnViewerKeystroke);
            this.listView1.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.OnHeaderClick);
            this.listView1.SelectedIndexChanged += new System.EventHandler(this.OnFeedItemSelect);
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Item";
            this.columnHeader1.Width = 350;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "Date";
            this.columnHeader2.Width = 150;
            // 
            // splitter2
            // 
            this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter2.Location = new System.Drawing.Point(227, 168);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(517, 3);
            this.splitter2.TabIndex = 3;
            this.splitter2.TabStop = false;
            // 
            // axWebBrowser1
            // 
            this.axWebBrowser1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.axWebBrowser1.Enabled = true;
            this.axWebBrowser1.Location = new System.Drawing.Point(227, 171);
            this.axWebBrowser1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
            this.axWebBrowser1.Size = new System.Drawing.Size(517, 356);
            this.axWebBrowser1.TabIndex = 4;
            // 
            // statusBar1
            // 
            this.statusBar1.Location = new System.Drawing.Point(227, 505);
            this.statusBar1.Name = "statusBar1";
            this.statusBar1.Size = new System.Drawing.Size(517, 22);
            this.statusBar1.TabIndex = 5;
            this.statusBar1.Text = "Ready.";
            // 
            // contextMenuTreeView
            // 
            this.contextMenuTreeView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                                this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.Text = "Refresh (F5)";
            this.menuItem1.Click += new System.EventHandler(this.onTreeViewRightClickRefresh);
            // 
            // contextMenuListView
            // 
            this.contextMenuListView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                                this.menuItem2});
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 0;
            this.menuItem2.Text = "Open in separate window";
            this.menuItem2.Click += new System.EventHandler(this.OnFeedItemRightClickOpenLink);
            // 
            // FeedViewer
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(744, 527);
            this.Controls.Add(this.statusBar1);
            this.Controls.Add(this.axWebBrowser1);
            this.Controls.Add(this.splitter2);
            this.Controls.Add(this.listView1);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.treeView1);
            this.Name = "FeedViewer";
            this.Text = "Windows RSS store Viewer";
            ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new FeedViewer());
        }

        public class FeedNode : TreeNode
        {
            Feed m_feed;

            public Feed Feed
            {
                get {
                    return m_feed;
                }
                set {
                    m_feed = value;
                }
            }
        }

        void PopulateTree()
        {
            Cursor = Cursors.WaitCursor;

            fs = new FeedStore();

            SecurityPermission perm = new SecurityPermission(SecurityPermissionFlag.UnmanagedCode);
            try
            {
                perm.Demand();
            }
            catch
            {
                MessageBox.Show("Sorry, this application requires full trust.");    
            }

            fs.Refresh();

            treeView1.Nodes.Clear();

            treeView1.BeginUpdate();

            foreach(Feed f in fs.Feeds())
            {
                string [] pathsplit = f.Path.Split(new Char [] {'\\'});

                TreeNodeCollection nodes = treeView1.Nodes;

                for (int iFolder = 0; iFolder < pathsplit.Length; iFolder++) 
                {
                    FeedNode node = new FeedNode();
                    node.Text = pathsplit[iFolder];

                    if (iFolder == pathsplit.Length - 1) // actual feed node
                    {
                        node.ImageIndex = 1;
                        node.SelectedImageIndex = 1;
                        node.Feed = f;
                        nodes.Add(node);
                    }
                    else // folder
                    {
                        node.ImageIndex = 0;
                        node.SelectedImageIndex = 0;

                        string name = pathsplit[iFolder];
                        // make sure we don't have it already
                        int nbNodes = nodes.Count;
                        int iNode;
                        for (iNode = 0; iNode < nbNodes; iNode++)
                        {
                            if (nodes[iNode].Text == name)
                            {
                                nodes = nodes[iNode].Nodes;
                                break;
                            }
                        }

                        if (iNode >= nbNodes)
                        {
                            node.Feed = null;
                            nodes.Add(node);
                            nodes = node.Nodes;
                        }
                    }
                } // end for all folders
            } // end for all feeds

            treeView1.EndUpdate();

            Cursor = Cursors.Default;
        }


        public class FeedListViewItem : ListViewItem
        {
            FeedItem m_feedItem;

            public FeedItem FeedItem
            {
                get 
                {
                    return m_feedItem;
                }
                set 
                {
                    m_feedItem = value;
                }
            }
        }

        private void onTreeItemSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            FeedNode node = (FeedNode) e.Node;
            if (node.Feed == null)
                return;

            node.Feed.Open(fs.FeedStorePath);

            listView1.Items.Clear();
            
            long nbItems = node.Feed.Items.Count;
            foreach (FeedItem fi in node.Feed.Items)
            {
                FeedListViewItem item = new FeedListViewItem();
                item.Text = fi.Name;
                item.FeedItem = fi;
                item.SubItems.Add(fi.Date);

                listView1.Items.Add(item);
            }


        }

        private void OnFeedItemSelect(object sender, System.EventArgs e)
        {
			ListView.SelectedListViewItemCollection selcoll = listView1.SelectedItems;

            foreach(FeedListViewItem fi in selcoll)
            {
                String body = "<html>" + 
                              "<head><META HTTP-EQUIV=\"Content-type\" CONTENT=\"text/html;charset=UTF-8\"></head><body>" + 
                              fi.FeedItem.Body + 
                              "</body></html>";

                String tmpfile = System.IO.Path.GetTempFileName();

                using (StreamWriter sw = new StreamWriter(tmpfile)) 
                {
                    sw.Write(body);
                }


                object o = new object();

                try
                {
                    this.axWebBrowser1.Navigate( "file:///" + tmpfile.Replace(@"\",@"/"), 
                        ref o/*ref object flags*/, 
                        ref o/*ref object targetframe*/,
                        ref o/*ref object postdata*/,
                        ref o/*ref object headers*/);
                }
                catch
                {
                }

            }

        }

        private void OnHeaderClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
        {
            // Set the ListViewItemSorter property to a new ListViewItemComparer object.
            this.listView1.ListViewItemSorter = new ListViewItemComparer(m_order, e.Column);
            // Call the sort method to manually sort the column based on the ListViewItemComparer implementation.
            listView1.Sort();

            m_order *= -1;
        }

        private void OnViewerKeystroke(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            if (e.KeyCode == Keys.F5)
                PopulateTree();
        }

        private void onTreeViewRightClickRefresh(object sender, System.EventArgs e)
        {
            PopulateTree();
        }

        private void OnFeedItemRightClickOpenLink(object sender, System.EventArgs e)
        {
            ListView.SelectedListViewItemCollection selcoll = listView1.SelectedItems;

            foreach(FeedListViewItem fi in selcoll)
            {
                if (fi.FeedItem.Link != null)
                    System.Diagnostics.Process.Start( fi.FeedItem.Link );
            }        
        }

        // Implements the manual sorting of items by columns.
        class ListViewItemComparer : IComparer 
        {
            private int _col;
            private int _order;
            public ListViewItemComparer() 
            {
                _col = 0;
            }
            public ListViewItemComparer(int order, int column) 
            {
                _col = column;
                _order = order;
            }
            public int Compare(object x, object y) 
            {
                return _order * String.Compare(
                             ((ListViewItem)x).SubItems[_col].Text, 
                             ((ListViewItem)y).SubItems[_col].Text);
            }
        }





	}
}
