using System;
using System.Runtime.InteropServices;
using System.Text;

namespace RSSStoreViewer
{

    // grabbed from www.pinvoke.net

	/// <summary>
	/// Summary description for NativeCalls.
	/// </summary>
	public class NativeCalls
	{
        public const int CSIDL_LOCAL_APPDATA = 0x001c;
        public const int SHGFP_TYPE_CURRENT = 0;
        public const int MAX_PATH = 256;

        public const int S_OK = 0;
        public const int STGM_SIMPLE = 0x08000000;
        public const int STGM_READ = 0x00000000;
        public const int STGM_SHARE_EXCLUSIVE = 0x00000010;

        public const int STGTY_STORAGE	= 1;
        public const int STGTY_STREAM	= 2;
        public const int STGTY_LOCKBYTES = 3;
        public const int STGTY_PROPERTY	= 4;


        [DllImport("shell32.dll")]
        public static extern Int32 SHGetFolderPath(IntPtr hwndOwner, 
            Int32 nFolder, IntPtr hToken, UInt32 dwFlags, StringBuilder pszPath); 

        [ComImport]
            [Guid("0000000d-0000-0000-C000-000000000046")]
            [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
            public interface IEnumSTATSTG
        {
            // The user needs to allocate an STATSTG array whose size is celt.
            [PreserveSig]
            uint Next(uint celt,
                [MarshalAs(UnmanagedType.LPArray), Out]STATSTG[] rgelt,
                out uint pceltFetched);

            void Skip(uint celt);

            void Reset();

            [return:MarshalAs(UnmanagedType.Interface)]IEnumSTATSTG Clone();
        }

        [ComImport]
            [Guid("0000000b-0000-0000-C000-000000000046")]
            [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
        public interface IStorage 
        {
            void CreateStream(
                /* [string][in] */ string pwcsName,
                /* [in] */ uint grfMode,
                /* [in] */ uint reserved1,
                /* [in] */ uint reserved2,
                /* [out] */ out UCOMIStream ppstm);

            void OpenStream(
                /* [string][in] */ string pwcsName,
                /* [unique][in] */ IntPtr reserved1,
                /* [in] */ uint grfMode,
                /* [in] */ uint reserved2,
                /* [out] */ out UCOMIStream ppstm);

            void CreateStorage(
                /* [string][in] */ string pwcsName,
                /* [in] */ uint grfMode,
                /* [in] */ uint reserved1,
                /* [in] */ uint reserved2,
                /* [out] */ out IStorage ppstg);

            void OpenStorage(
                /* [string][unique][in] */ string pwcsName,
                /* [unique][in] */ IStorage pstgPriority,
                /* [in] */ uint grfMode,
                /* [unique][in] */ IntPtr snbExclude,
                /* [in] */ uint reserved,
                /* [out] */ out IStorage ppstg);

            void CopyTo(
                /* [in] */ uint ciidExclude,
                /* [size_is][unique][in] */ Guid rgiidExclude,
                /* [unique][in] */ IntPtr snbExclude,
                /* [unique][in] */ IStorage pstgDest);

            void MoveElementTo(
                /* [string][in] */ string pwcsName,
                /* [unique][in] */ IStorage pstgDest,
                /* [string][in] */ string pwcsNewName,
                /* [in] */ uint grfFlags);

            void Commit(
                /* [in] */ uint grfCommitFlags);

            void Revert();

            void EnumElements(
                /* [in] */ uint reserved1,
                /* [size_is][unique][in] */ IntPtr reserved2,
                /* [in] */ uint reserved3,
                /* [out] */ out IEnumSTATSTG ppenum);

            void DestroyElement(
                /* [string][in] */ string pwcsName);

            void RenameElement(
                /* [string][in] */ string pwcsOldName,
                /* [string][in] */ string pwcsNewName);

            void SetElementTimes(
                /* [string][unique][in] */ string pwcsName,
                /* [unique][in] */ FILETIME pctime,
                /* [unique][in] */ FILETIME patime,
                /* [unique][in] */ FILETIME pmtime);

            void SetClass(
                /* [in] */ Guid clsid);

            void SetStateBits(
                /* [in] */ uint grfStateBits,
                /* [in] */ uint grfMask);

            void Stat(
                /* [out] */ out STATSTG pstatstg,
                /* [in] */ uint grfStatFlag);

        }

        [DllImport("ole32.dll")]
        public static extern int StgOpenStorage([MarshalAs(UnmanagedType.LPWStr)] string
            pwcsName, IStorage pstgPriority, uint grfMode, IntPtr snbExclude, uint
            reserved, out IStorage ppstgOpen);
    }
}
